class HdaAppWeightwatcherController < ApplicationController
  require 'gruff'

  def index
    @page_title = "Weight Watcher"

    @name =""
    unless params[:weight].nil?
    	name = params[:weight][:name_tf].nil? ? params[:weight][:name] : params[:weight][:name_tf]
    	date = Date.civil(params[:weight][:"date(1i)"].to_i,params[:weight][:"date(2i)"].to_i,params[:weight][:"date(3i)"].to_i)
    	HdaAppWeightwatcher.destroy_all(["name = ? and date = ?", name, date])
    	w = HdaAppWeightwatcher.new(:name => name.strip, :date => date, :weight => params[:weight][:weight])
    	w.save
    	@name = name
    end
    @users = users_of(HdaAppWeightwatcher.find(:all))
    @display = Hash[* @users.map{ |u| [u, params[:view].nil? ? true : (params[:view][u] == "false") ] }.flatten ]
  end

  def graph
    g = Gruff::Line.new(600)
    g.theme_37signals
    g.title = "Weight Watcher"

    view = params[:view]
    time_back = 30
    @users = users_of(HdaAppWeightwatcher.find(:all, :order => ["date ASC"]))
    # FIXME: there are probably a ton of ways more efficient than this!
    @users.each do |u|
      unless view.nil?
	if view[u] == "true"
		g.data u, user_weights(u, time_back)
	end
      end
    end
    g.labels = days2labels time_back
    send_data(g.to_blob, 
            :disposition => 'inline', 
            :type => 'image/png', 
            :filename => "hda_app_weightwatcher.png")
  end

  def showhide
    @users = users_of(HdaAppWeightwatcher.find(:all))
    view = params[:view]
    if view.nil?
    	@display = Hash[* @users.map{ |u| [u, true] }.flatten ]
    else
	@display = Hash[* @users.map{ |u| [u, params[:id] == u ? (view[u] == "false") : (view[u] == "true") ] }.flatten ]
    end
    render :partial => 'users', :layout => false
  end

  def delete
    HdaAppWeightwatcher.find(:all, :conditions =>  ["binary name = ?", params[:id]]).map{ |w| w.destroy }
    @users = users_of(HdaAppWeightwatcher.find(:all))
    @display = Hash[* @users.map{ |u| [u, true] }.flatten ]
    render :partial => 'users', :layout => false
  end

protected

  def users_of(list)
	(list.map{ |l| l.name }).uniq
  end

  def user_weights_for_date(u, date, weights)
	previous=nil
 	weights.map do |w|
		previous = w.weight
		return previous if (w.date.to_date <=> date) >= 0
  	end
	return previous
  end

  def user_weights(u, time_back)
      data = [];
      today = Date.today
      weights = HdaAppWeightwatcher.find(:all, :conditions => ["binary name = ?", u], :order => ["date ASC"])
      0.upto(time_back) do |day|
	      date = today - time_back + day
	      data += [ user_weights_for_date(u, date, weights) ]
      end
      data
  end

  def days2labels(days_back)
    label = {}
    today = Date.today
    0.upto(days_back) do |day|
	d = today - days_back + day
	if (days_back > 7) # greater than a week, label every 7 days
		if ((days_back - day + 1) % 7) == 1
			label[day] = [d.month, d.day].join '/'
		end
	else
		label[day] = [d.month, d.day].join '/'
	end
    end
    label
  end
end
