class HdaAppWeightwatcherInstaller
	def up
	  appname = "weightwatcher"
	  app = "hda_app_" + appname
	  tgt = "#{HDA_BASE}/platform/html"
	  FileUtils.cd("#{HDA_BASE}/platform/apps/#{appname}") do
	    FileUtils.cp("app/controllers/#{app}_controller.rb", "#{tgt}/app/controllers")
	    FileUtils.cp("app/models/#{app}.rb", "#{tgt}/app/models")
	    FileUtils.mkdir_p("#{tgt}/app/views/#{app}")
	    FileUtils.cp_r("app/views/#{app}", "#{tgt}/app/views/")
	  end
	  WeightTables.migrate :up
	  # pid = HdaPackage.find(:first, :conditions => "name='#{appname}'")[:id]
	  # HdaApplication.new(:hda_package_id => pid, :hda_user_id => 1).save
	  load "#{tgt}/app/models/#{app}.rb"
	  load "#{tgt}/app/controllers/#{app}_controller.rb"
	  true
	end

	def down
	  appname = "weightwatcher"
	  app = "hda_app_" + appname
	  tgt = "#{HDA_BASE}/platform/html"
	  WeightTables.migrate :down
	  FileUtils.cd(tgt) do
	    FileUtils.rm("app/controllers/#{app}_controller.rb", :force => true)
	    FileUtils.rm("app/models/#{app}.rb", :force => true)
	    FileUtils.rm_r("app/views/#{app}", :force => true)
	  end
	  # pid = HdaPackage.find(:first, :conditions => "name='#{appname}'")[:id]
	  # HdaApplication.find(:all, :conditions => "hda_package_id='#{pid}'").each {|r| r.destroy}
	  #Object.__send__(:remove_const, 'HdaAppweightwatcherController')
	  true
	end

	def user_up u
	  true
	end

end

class WeightTables < ActiveRecord::Migration
	def self.up
	  begin
	      create_table :hda_app_weightwatchers do |t|
	        t.column :name, :string
	        t.column :weight, :float
	        t.column :date, :datetime
	      end
	  rescue
	    #do nothing - the db was already created
	  end
	  self.populate
	end

	def self.down
	  # dont' destroy data!
	  # drop_table :hda_app_weightwatchers
	end

	def self.generate_user(name, start_weight, diff, incr)
		weight = start_weight
		1.month.ago.to_date.step(Date.today) do |date|
			HdaAppWeightwatcher.create(:name => name, :date => date, :weight => weight)
			weight += rand(diff) - diff/2 - incr
		end
	end

	def self.populate
		self.generate_user("user1", 145, 4, 0.3)
		self.generate_user("user2", 167, 2, 0.1)
		self.generate_user("user3", 187, 5, -0.3)
		self.generate_user("user4", 203, 4, 0.1)
	end

end

